"""create Player model

Revision ID: 18230eaed37b
Revises: 64a9cb33ade4
Create Date: 2021-10-04 10:33:41.827455

"""
from collections import namedtuple, defaultdict

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import postgresql
from sqlalchemy.sql.expression import text

# revision identifiers, used by Alembic.
revision = '18230eaed37b'
down_revision = '64a9cb33ade4'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        'player',
        sa.Column('id', sa.Integer(), nullable=False),
        sa.Column('game_id', sa.Integer(), nullable=False),
        sa.Column('user_id', sa.Integer(), nullable=False),
        sa.Column(
            'virus',
            sa.Enum('CROSS', 'ZERO', name='player_virus'),
            nullable=False
        ),
        sa.Column('color', sa.String(length=10), nullable=False),
        sa.Column('result', sa.String(length=4), nullable=True),
        sa.CheckConstraint(
            "color='black' OR color='red' OR color='orange' OR "
            "color='green' OR color='purple'",
            name='color_check'
        ),
        sa.CheckConstraint(
            "result='win' OR result='lose' OR result='draw'",
            name='result_check'
        ),
        sa.ForeignKeyConstraint(['game_id'], ['game.id'], ),
        sa.ForeignKeyConstraint(['user_id'], ['user.id'], ),
        sa.PrimaryKeyConstraint('id'),
        sa.UniqueConstraint('game_id', 'color', name='game_color_unq'),
        sa.UniqueConstraint('game_id', 'user_id', name='game_user_unq'),
        sa.UniqueConstraint('game_id', 'virus', name='game_virus_unq')
    )

    # extract players from game
    connection = op.get_bind()
    fields = (
        'id', 'first_user_id', 'second_user_id', 'first_user_color',
        'second_user_color', 'first_user_virus', 'winner_id', 'is_ended'
    )
    res = connection.execute(
        text(
            f"SELECT {', '.join(fields)} FROM game"
        )
    )
    Game = namedtuple('game', fields)
    games = [Game(*game) for game in res.fetchall()]
    for game in games:
        if not game.is_ended:
            result_first_user = 'NULL'
            result_second_user = 'NULL'
        elif game.winner_id is None:
            result_first_user = "'draw'"
            result_second_user = "'draw'"
        else:
            result_first_user =\
                "'win'" if game.winner_id == game.first_user_id else "'lose'"
            result_second_user =\
                "'lose'" if game.winner_id == game.first_user_id else "'win'"
        connection.execute(
            text(
                "INSERT INTO player (game_id, user_id, virus, color, result) "
                "VALUES ("
                f"{game.id}, {game.first_user_id}, '{game.first_user_virus}', "
                f"'{game.first_user_color}', {result_first_user}"
                ")"
            )
        )
        second_user_virus =\
            'ZERO' if game.first_user_virus == 'CROSS' else 'CROSS'
        if game.second_user_id is not None:
            connection.execute(
                text(
                    "INSERT INTO player "
                    "(game_id, user_id, virus, color, result) "
                    "VALUES ("
                    f"{game.id}, {game.second_user_id}, "
                    f"'{second_user_virus}', "
                    f"'{game.second_user_color}', {result_second_user}"
                    ")"
                )
            )

    op.drop_constraint('game_first_user_color_check', 'game', type_='check')
    op.drop_constraint('game_second_user_color_check', 'game', type_='check')
    op.drop_constraint('game_second_user_id_fkey', 'game', type_='foreignkey')
    op.drop_constraint('game_winner_id_fkey', 'game', type_='foreignkey')
    op.drop_constraint('game_first_user_id_fkey', 'game', type_='foreignkey')
    op.drop_column('game', 'first_user_virus')
    op.drop_column('game', 'first_user_id')
    op.drop_column('game', 'second_user_id')
    op.drop_column('game', 'first_user_color')
    op.drop_column('game', 'second_user_color')
    op.drop_column('game', 'winner_id')
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        'game',
        sa.Column(
            'winner_id', sa.INTEGER(), autoincrement=False, nullable=True
        )
    )
    op.add_column(
        'game',
        sa.Column(
            'second_user_color',
            sa.VARCHAR(length=10),
            server_default=sa.text("'black'::character varying"),
            autoincrement=False,
            nullable=True
        )
    )
    op.add_column(
        'game',
        sa.Column(
            'first_user_color',
            sa.VARCHAR(length=10),
            server_default=sa.text("'black'::character varying"),
            autoincrement=False,
            nullable=True
        )
    )
    op.add_column(
        'game',
        sa.Column(
            'second_user_id', sa.INTEGER(), autoincrement=False, nullable=True
        )
    )
    op.add_column(
        'game',
        sa.Column(
            'first_user_id',
            sa.INTEGER(),
            autoincrement=False,
            nullable=True
        )
    )
    op.add_column(
        'game',
        sa.Column(
            'first_user_virus',
            postgresql.ENUM('CROSS', 'ZERO', name='virus'),
            autoincrement=False,
            nullable=True
        )
    )
    op.create_foreign_key(
        'game_first_user_id_fkey', 'game', 'user', ['first_user_id'], ['id']
    )
    op.create_foreign_key(
        'game_winner_id_fkey', 'game', 'user', ['winner_id'], ['id']
    )
    op.create_foreign_key(
        'game_second_user_id_fkey', 'game', 'user', ['second_user_id'], ['id']
    )
    op.create_check_constraint(
        'game_first_user_color_check',
        'game',
        "(first_user_color = 'black') OR (first_user_color = 'red') OR "
        "(first_user_color = 'orange') OR (first_user_color = 'green') OR "
        "(first_user_color = 'purple')"
    )
    op.create_check_constraint(
        'game_second_user_color_check',
        'game',
        "(second_user_color = 'black') OR (second_user_color = 'red') OR "
        "(second_user_color = 'orange') OR (second_user_color = 'green') OR "
        "(second_user_color = 'purple')"
    )

    # insert players to game
    connection = op.get_bind()
    fields = ('game_id', 'user_id', 'virus', 'color', 'result')
    res = connection.execute(
        text(
            f"SELECT {', '.join(fields)} FROM player"
        )
    )
    Player = namedtuple('player', fields)
    players = defaultdict(list)
    for player in [Player(*data) for data in res.fetchall()]:
        players[player.game_id].append(player)
        if len(players[player.game_id]) > 2:
            raise ValueError('Too many players (great than 2) in game.')
    for player_list in players.values():
        if len(player_list) == 1 or player_list[0].result is None:
            is_ended = False
            winner_id = 'NULL'
        elif player_list[0].result == 'win':
            is_ended = True
            winner_id = player_list[0].user_id
        elif player_list[0].result == 'draw':
            is_ended = True
            winner_id = 'NULL'
        else:
            is_ended = True
            winner_id = player_list[1].user_id

        for player in player_list:
            if player.virus == 'CROSS':
                connection.execute(
                    text(
                        "UPDATE game SET "
                        f"first_user_id={player.user_id}, "
                        f"first_user_color='{player.color}', "
                        f"first_user_virus='{player.virus}', "
                        f"is_ended={is_ended}, "
                        f"winner_id={winner_id} "
                        f"WHERE id={player.game_id}"
                    )
                )
            else:
                connection.execute(
                    text(
                        "UPDATE game SET "
                        f"second_user_id={player.user_id}, "
                        f"second_user_color='{player.color}' "
                        f"WHERE id={player.game_id}"
                    )
                )

    op.alter_column('game', 'second_user_color', nullable=False)
    op.alter_column('game', 'first_user_color', nullable=False)
    op.alter_column('game', 'first_user_id', nullable=False)
    op.alter_column('game', 'first_user_virus', nullable=False)
    op.drop_table('player')
    op.execute("DROP TYPE player_virus;")
    # ### end Alembic commands ###
